/***********************************************************************************
 *                                                                                 *
 * Matthew C. Berntsen, Bucknell University 2005                                   *
 * Thesis Project for Honors in Computer Science                                   *
 * Spring 2005                                                                     *
 *                                                                                 *
 * http://mattberntsen.net?page=thesis                                             *
 *                                                                                 *
 ***********************************************************************************

Description: This file is used to prepare dictionary files (ASCII files
             containing a list of words) by removing all words that contain 
             characters that are not standard American English letters.

*************************************************************************************/

using namespace std;
#include <fstream>
#include <string>

int main(int argc, char* argv[]){

    // Validate Input
    if(argc != 2 || strlen(argv[1]) > 250){
	printf("Error. Please check the input parameters.\n");
	exit(-1);
    }

    // Validate and open file
    ifstream inFile(argv[1]);
    if(!inFile.is_open()){
	printf("Invalid input filename.\n");
	exit(-1);
    }

    // Open output file.
    ofstream outFile(strcat(argv[1], ".dictPrep"));
    if(!outFile.is_open()){
	printf("Cannot write to output file.\n");
	exit(-1);
    }

    // Process
    string tempW;
    unsigned int i;
    while(inFile >> tempW){
	for(i = 0; i < tempW.size(); i++)
	    if(!isalpha(tempW[i]))
		break;
	if(i == tempW.size())
	    outFile << tempW << '\n';
    }
    outFile.close();
    inFile.close();
}
