/***********************************************************************************
 *                                                                                 *
 * Matthew C. Berntsen, Bucknell University 2005                                   *
 * Thesis Project for Honors in Computer Science                                   *
 * Spring 2005                                                                     *
 *                                                                                 *
 * http://mattberntsen.net?page=thesis                                             *
 *                                                                                 *
 ***********************************************************************************

 Description: This class handles encryption and decryption of the vigenere cipher.

 ************************************************************************************/

#ifndef __VIGCRYPT_H
#define __VIGCRYPT_H

using namespace std;
#include <string>

class vigCrypt{

public:
    // Pre:  inMaxP and inMaxF are valid.
    // Post: maxP and maxF are set
    // Runtime O(1)
    vigCrypt(unsigned int, unsigned int);

    // Pre: passphrase, encrypt, file and mode are all valid.
    // Post: values are initialized accordingly.
    // Runtime: O(M + P) where M is the number of characters in the input file and
    //          P is the length of the passphrase
    bool crypt(int, bool, string, string);
    
    // Pre: None.
    // Post: Any allocated memory is deallocated.
    // Runtime O(1)
    ~vigCrypt();

private:
    short int *passI;
    unsigned int maxP;
    unsigned int maxF;
    char ** tableau;
    int counter;
    char tempC;
    unsigned int i;
    unsigned int j;
};

#endif
